# -*- coding: utf-8 -*-
"""
Created on Mon Jun 26 20:56:38 2023

@author: maxamed.nuurmaxa
"""

import os
import mes_fonctions

from skimage.metrics import structural_similarity as compare_ssim
import argparse
import imutils
import cv2
import matplotlib.pyplot as plt
import os
import numpy as np

from PIL import Image


# Chemin du dossier courant (où se trouve le fichier Python)
dossier_courant = os.path.dirname(os.path.abspath(__file__))

# Chemin du dossier "Images"
dossier_images = os.path.join(dossier_courant, r"Images")

# Chemin des sous-dossiers
chemin_reference = os.path.join(dossier_images, r"Reference")
chemin_modifier = os.path.join(dossier_images, r"Modifier")

# Liste pour les images de "Reference"
images_reference = []

# Liste pour les images de chaque sous-dossier de "Modifier"
images_modifier = []

# Parcours des images dans le dossier "Reference"
for fichier in os.listdir(chemin_reference):
    chemin_image = os.path.join(chemin_reference, fichier)
    if os.path.isfile(chemin_image):
        images_reference.append(chemin_image)

# Parcours des sous-dossiers dans le dossier "Modifier"
for fichier in os.listdir(chemin_modifier):
    chemin_image = os.path.join(chemin_modifier, fichier)
    if os.path.isfile(chemin_image):
        images_modifier.append(chemin_image)


# Affichage des listes d'images
print("Images de Reference :")
for image in images_reference:
    pass
    # print(image)

print("/nImages de Modifier :")
for i, images_sous_dossier in enumerate(images_modifier):
    print(f"Sous-dossier {i+1}:")
    for image in images_sous_dossier:
        pass
        # print(image)


indice = 0

target_size = (150,200)

# Charger l'image de référence et la redimensionner à la taille cible avec interpolation
imageRef = cv2.imread(images_reference[indice])
imageRef = cv2.resize(imageRef, target_size, interpolation=cv2.INTER_AREA)

# Charger l'image de référence en niveaux de gris et la redimensionner à la taille cible avec interpolation
imageRefGray = cv2.imread(images_reference[indice], cv2.IMREAD_GRAYSCALE)
imageRefGray = cv2.resize(imageRefGray, target_size, interpolation=cv2.INTER_AREA)

# Charger l'image alternative et la redimensionner à la taille cible avec interpolation
ImageAlt = cv2.imread(images_modifier[indice])
ImageAlt = cv2.resize(ImageAlt, target_size, interpolation=cv2.INTER_AREA)

# Charger l'image alternative en niveaux de gris et la redimensionner à la taille cible avec interpolation
imageAltGray = cv2.imread(images_modifier[indice], cv2.IMREAD_GRAYSCALE)
imageAltGray = cv2.resize(imageAltGray, target_size, interpolation=cv2.INTER_AREA)

# Appliquer l'égalisation d'histogramme sur l'image alternative en niveaux de gris
imageAltGray_equalized = cv2.equalizeHist(imageAltGray)
# Convertir l'image égalisée en niveaux de gris en image couleur
imageAltequalized = cv2.cvtColor(imageAltGray_equalized, cv2.COLOR_GRAY2BGR)

# Appliquer l'égalisation d'histogramme sur l'image de référence en niveaux de gris
imageRefGray_equalized = cv2.equalizeHist(imageRefGray)
# Convertir l'image égalisée en niveaux de gris en image couleur
imageRefequalized = cv2.cvtColor(imageRefGray_equalized, cv2.COLOR_GRAY2BGR)


mes_fonctions.afficher_images(imageRef, ImageAlt)

print("Taille imageRef : ", imageRef.shape, "Taille ImageAlt : ", ImageAlt.shape)

#%% Détection contour coffret référence

thresh = cv2.threshold(imageRef,0 ,200, cv2.THRESH_BINARY_INV)[1] # 195

# Appliquer la détection de contour en utilisant cv2.Canny()
edges = cv2.Canny(imageRef, 50, 150)  # Utilisez les seuils appropriés pour votre cas

plt.imshow(edges, cmap='gray')
plt.axis('off')
plt.show()

# mes_fonctions.afficher_images(imageRef, thresh)

# # # Recherche des contours dans l'image seuillée
cnts = cv2.findContours(edges, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
cnts = imutils.grab_contours(cnts)

# Tri des contours par aire (surface)
cnts = sorted(cnts, key=cv2.contourArea, reverse=True)

# Créer une image vierge de la même taille que diff
contour_image = np.zeros_like(imageRef)

# Vérifier s'il y a des contours détectés
if len(cnts) > 0:
    # Parcourir les indices des contours et les afficher individuellement
    for index_contour in range(min(4, len(cnts))):
        # Vérifier que l'indice de contour est dans la plage valide
        if index_contour < len(cnts):
            # Créer une copie de l'image vierge à chaque itération
            contour_image_current = contour_image.copy()

            # Dessiner le contour sélectionné sur l'image vierge
            cv2.drawContours(contour_image_current, cnts, index_contour, 255, thickness=2)

            # Afficher l'image avec le contour sélectionné
            plt.imshow(contour_image_current, cmap='gray')
            plt.axis('off')
            plt.show()
else:
    print("Aucun contour détecté dans l'image")

#%% Cropper l'image de référence

# Recherche des contours dans l'image seuillée
cnts = cv2.findContours(edges, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
cnts = imutils.grab_contours(cnts)

# Tri des contours par aire (surface)
cnts = sorted(cnts, key=cv2.contourArea, reverse=True)

# Vérifier s'il y a des contours détectés
if len(cnts) > 0:
    # Sélectionner le premier contour (le plus grand)
    cnt = cnts[0]

    # Obtenir les coordonnées du rectangle englobant du contour
    x, y, w, h = cv2.boundingRect(cnt)

    # Recadrer l'image en utilisant les coordonnées du rectangle englobant
    # cropped_image_ref = imageRefequalized[y:y+h, x:x+w]
    cropped_image_ref = imageRef[y:y+h, x:x+w]

    # Afficher l'image recadrée
    plt.imshow(cropped_image_ref, cmap='gray')
    plt.axis('off')
    plt.show()
else:
    print("Aucun contour détecté dans l'image")


#%% Correlation avec image qui contient une erreur

# Convertir l'image recadrée en couleur
# color_cropped_image = cv2.cvtColor(cropped_image, cv2.COLOR_GRAY2BGR)
h, w, _ = cropped_image_ref.shape

# Afficher les dimensions de l'image recadrée
# h, w = cropped_image.shape[:2]
# Afficher les dimensions
print("Largeur :", w)
print("Hauteur :", h)

methods = ['cv2.TM_CCOEFF'] # 'cv2.TM_CCOEFF', 'cv2.TM_CCOEFF_NORMED', 'cv2.TM_CCORR', 'cv2.TM_CCORR_NORMED',

# Charger l'image de référence
cropped_ImageRef = np.array(cropped_image_ref)  # Convertir l'image en tableau NumPy

# Boucle à travers chaque méthode de correspondance
for meth in methods:
  # Copier l'image alternative pour chaque itération de la boucle
  img = ImageAlt.copy()
  # Copier l'image de référence recadrée pour chaque itération de la boucle
  ImageRef = cropped_ImageRef.copy()
  # Évaluation de la méthode de correspondance actuelle
  method = eval(meth)
  # Affichage des dimensions de l'image img
  print("Dimensions de l'image img :", img.shape)
  # Affichage des dimensions de l'image ImageRef
  print("Dimensions de l'image ImageRef :", ImageRef.shape)
  
  # Application de la correspondance de modèle
  res = cv2.matchTemplate(img, ImageRef, method)
  # Récupération des valeurs minimales et maximales, ainsi que des emplacements correspondants
  min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(res)
  
  # Si la méthode est TM_SQDIFF ou TM_SQDIFF_NORMED, prendre la valeur minimale
  if method in [cv2.TM_SQDIFF, cv2.TM_SQDIFF_NORMED]:
    top_left = min_loc
  else:
    top_left = max_loc
    bottom_right = (top_left[0] + w, top_left[1] + h)
    
    # Rogner l'image en utilisant les coordonnées spécifiées
    résultat_image_cropped_ref = ImageRef[top_left[1]:bottom_right[1], top_left[0]:bottom_right[0]]
    # Dessiner un rectangle autour de la zone correspondante sur l'image img
    cv2.rectangle(img, top_left, bottom_right, (0, 0, 255), 2)
    
    # Afficher les résultats de correspondance
    plt.figure(meth, figsize=(9, 8))
    plt.subplot(121), plt.imshow(res, cmap='gray')
    plt.title(meth), plt.axis("off")
    plt.subplot(122), plt.imshow(cv2.cvtColor(img, cv2.COLOR_BGR2RGB))
    plt.title('Localisation du modèle'), plt.axis("off")

    

#%% Détection coffret différent

thresh = cv2.threshold(ImageAlt,0 ,200, cv2.THRESH_BINARY_INV)[1] # 195

# Appliquer la détection de contour en utilisant cv2.Canny()
edges = cv2.Canny(ImageAlt,100, 255)  # Utilisez les seuils appropriés pour votre cas

plt.imshow(edges, cmap='gray')
plt.axis('off')
plt.show()

# mes_fonctions.afficher_images(imageRef, thresh)

# # # Recherche des contours dans l'image seuillée
cnts = cv2.findContours(edges, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
cnts = imutils.grab_contours(cnts)

# Tri des contours par aire (surface)
cnts = sorted(cnts, key=cv2.contourArea, reverse=True)

# Créer une image vierge de la même taille que diff
contour_image = np.zeros_like(ImageAlt)

# Vérifier s'il y a des contours détectés
if len(cnts) > 0:
    # Parcourir les indices des contours et les afficher individuellement
    for index_contour in range(min(4, len(cnts))):
        # Vérifier que l'indice de contour est dans la plage valide
        if index_contour < len(cnts):
            # Créer une copie de l'image vierge à chaque itération
            contour_image_current = contour_image.copy()

            # Dessiner le contour sélectionné sur l'image vierge
            cv2.drawContours(contour_image_current, cnts, index_contour, 255, thickness=2)

            # Afficher l'image avec le contour sélectionné
            plt.imshow(contour_image_current, cmap='gray')
            plt.axis('off')
            plt.show()
else:
    print("Aucun contour détecté dans l'image")
    
#%% Cropper l'image de erreur

# Recherche des contours dans l'image seuillée
cnts = cv2.findContours(edges, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
cnts = imutils.grab_contours(cnts)

# Tri des contours par aire (surface)
cnts = sorted(cnts, key=cv2.contourArea, reverse=True)

# Vérifier s'il y a des contours détectés
if len(cnts) > 0:
    # Sélectionner le premier contour (le plus grand)
    cnt = cnts[0]

    # Obtenir les coordonnées du rectangle englobant du contour
    x, y, w, h = cv2.boundingRect(cnt)

    # Recadrer l'image en utilisant les coordonnées du rectangle englobant
    # cropped_image_alt = imageAltequalized[y:y+h, x:x+w]
    cropped_image_alt = ImageAlt[y:y+h, x:x+w]

    # Afficher l'image recadrée
    plt.imshow(cropped_image_alt, cmap='gray')
    plt.axis('off')
    plt.show()
else:
    print("Aucun contour détecté dans l'image")


#%% Corrélation avec image de référence

# Convertir l'image recadrée en couleur
# color_cropped_image = cv2.cvtColor(cropped_image_alt, cv2.COLOR_GRAY2BGR)
h, w, _ = cropped_image_alt.shape

# Afficher les dimensions de l'image recadrée
# h, w = cropped_image.shape[:2]
# Afficher les dimensions
print("Largeur :", w)
print("Hauteur :", h)

methods = ['cv2.TM_CCOEFF'] # 'cv2.TM_CCOEFF', 'cv2.TM_CCOEFF_NORMED', 'cv2.TM_CCORR', 'cv2.TM_CCORR_NORMED',

# Charger l'image de référence
cropped_ImageAlt = np.array(cropped_image_alt)  # Convertir l'image en tableau NumPy

for meth in methods:
  # Copier l'image de référence pour chaque itération de la boucle
  img = imageRef.copy()
  # Copier l'image alternative recadrée pour chaque itération de la boucle
  ImageRef = cropped_ImageAlt.copy()
  # Évaluation de la méthode de correspondance actuelle
  method = eval(meth)
  # Affichage des dimensions de l'image img
  print("Dimensions de l'image img :", img.shape)
  # Affichage des dimensions de l'image ImageRef
  print("Dimensions de l'image ImageRef :", ImageRef.shape)
  
  # Application de la correspondance de modèle
  res = cv2.matchTemplate(img, ImageRef, method)
  # Récupération des valeurs minimales et maximales, ainsi que des emplacements correspondants
  min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(res)
  
  # Si la méthode est TM_SQDIFF ou TM_SQDIFF_NORMED, prendre la valeur minimale
  if method in [cv2.TM_SQDIFF, cv2.TM_SQDIFF_NORMED]:
    top_left = min_loc
  else:
    top_left = max_loc
    bottom_right = (top_left[0] + w, top_left[1] + h)
    
    # Rogner l'image en utilisant les coordonnées spécifiées
    résultat_image_cropped_alt = ImageAlt[top_left[1]:bottom_right[1], top_left[0]:bottom_right[0]]
    # Dessiner un rectangle autour de la zone correspondante sur l'image img
    cv2.rectangle(img, top_left, bottom_right, (0, 0, 255), 2)
    
    # Afficher les résultats de correspondance
    plt.figure(meth, figsize=(9, 8))
    plt.subplot(121), plt.imshow(res, cmap='gray')
    plt.title(meth), plt.axis("off")
    plt.subplot(122), plt.imshow(cv2.cvtColor(img, cv2.COLOR_BGR2RGB))
    plt.title('Localisation du modèle'), plt.axis("off")

#%% Afficher les images rogner avant d'appliquer la différence

# Obtenir les dimensions de l'image alternative recadrée
height_alt, width_alt, _ = cropped_image_alt.shape
# Redimensionner l'image de référence recadrée pour qu'elle ait les mêmes dimensions que l'image alternative recadrée
cropped_image_ref_resize = cv2.resize(cropped_image_ref, (width_alt, height_alt))


# Appeler la fonction "afficher_images" pour afficher les images côte à côte
mes_fonctions.afficher_images(cropped_image_ref_resize, cropped_image_alt)

# Appeler la fonction "superposer_images" pour superposer les images
mes_fonctions.superposer_images(cropped_image_ref_resize, cropped_image_alt)

# Convertir l'image alternative recadrée en niveaux de gris
gray_cropped_ImageAlt = cv2.cvtColor(cropped_ImageAlt, cv2.COLOR_BGR2GRAY)
# Convertir l'image de référence recadrée redimensionnée en niveaux de gris
gray_cropped_ImageRef = cv2.cvtColor(cropped_image_ref_resize, cv2.COLOR_BGR2GRAY)

# Appeler la fonction "process_images" pour obtenir la différence entre les deux images en niveaux de gris
diff = mes_fonctions.process_images(gray_cropped_ImageRef, gray_cropped_ImageAlt)

mes_fonctions.afficher_image(diff)

#%% Seuillage de la différence

thresh = cv2.threshold(diff, 20,255, cv2.THRESH_BINARY_INV)[1] # 2 objets


mes_fonctions.afficher_image(thresh)

#%% Afficher les contours détecter

# Recherche des contours dans l'image seuillée
cnts = cv2.findContours(thresh.copy(), cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
cnts = imutils.grab_contours(cnts)

# Tri des contours par aire (surface)
cnts = sorted(cnts, key=cv2.contourArea, reverse=True)

# Créer une image vierge de la même taille que diff
contour_image = np.zeros_like(diff)

# Parcourir les indices des contours et les afficher individuellement
for index_contour in range(3):
    # Créer une copie de l'image vierge à chaque itération
    contour_image_current = contour_image.copy()

    # Dessiner le contour sélectionné sur l'image vierge
    cv2.drawContours(contour_image_current, cnts, index_contour, (255, 255, 255), thickness=2)

    # Afficher l'image avec le contour sélectionné
    mes_fonctions.afficher_image(contour_image_current)
#%% Détection de contour et affichage du résultat finale

 # Dessiner le rectangle

pourcentage_marge= 1
nombre_objet=3
seuil_taille=0.001

# Obtenir les dimensions de l'image
height, width = cropped_ImageAlt.shape[:2]

# Calcul de la marge pour exclure les contours proches des bords
marge = int(min(height, width) * (pourcentage_marge / 100))

# Créer une nouvelle liste pour stocker les contours valides
cnts_valides = []

# Parcourir tous les contours
for contour in cnts:
    # Obtenir le rectangle englobant du contour
    x, y, w, h = cv2.boundingRect(contour)

    # Vérifier si le contour touche les bords de l'image
    if x > marge and y > marge and x + w < width - marge and y + h < height - marge:
        # Ajouter le contour à la liste des contours valides
        cnts_valides.append(contour)

# Trier les contours valides par aire (en ordre décroissant)
cnts_valides = sorted(cnts_valides, key=cv2.contourArea, reverse=True)

# Rogner les objets inférieurs à un air de 3%
hauteur, largeur, _ = cropped_ImageAlt.shape
cnts_valides_rogner = cnts_valides[:nombre_objet]

# Créer une image vierge de la même taille que diff
contour_image = np.zeros_like(diff)

# Parcourir les indices des contours et les afficher individuellement
for index_contour in range(len(cnts_valides_rogner)):
    # Créer une copie de l'image vierge à chaque itération
    contour_image_current = contour_image.copy()

    # Dessiner le contour sélectionné sur l'image vierge
    cv2.drawContours(contour_image_current, cnts_valides_rogner, index_contour, (255, 255, 255), thickness=2)

    # Afficher l'image avec le contour sélectionné
    mes_fonctions.afficher_image(contour_image_current)

aire_totale = hauteur * largeur
seuil_taille = seuil_taille * aire_totale  # Seuil de taille à 3% de l'aire totale

cnts_valides_filtres = []
for contour in cnts_valides_rogner:
    aire_contour = cv2.contourArea(contour)
    print("Aire du contour :", aire_contour)
    if aire_contour > seuil_taille:
        cnts_valides_filtres.append(contour)
        

# Créer une image vierge de la même taille que diff
contour_image = np.zeros_like(diff)

# # Parcourir les indices des contours et les afficher individuellement
for index_contour in range(3):
    # Créer une copie de l'image vierge à chaque itération
    contour_image_current = contour_image.copy()

    # Dessiner le contour sélectionné sur l'image vierge
    cv2.drawContours(contour_image_current, cnts_valides_filtres, index_contour, (255, 255, 255), thickness=2)

    # Afficher l'image avec le contour sélectionné
    mes_fonctions.afficher_image(contour_image_current)

# Dessiner les rectangles autour des objets filtrés
for c in cnts_valides_filtres:
    (x, y, w, h) = cv2.boundingRect(c)
    cv2.rectangle(cropped_ImageAlt, (x, y), (x + w, y + h), (255, 0, 0), 2)


mes_fonctions.afficher_image(cropped_ImageAlt)
mes_fonctions.afficher_images( cropped_ImageRef, cropped_ImageAlt)


