# TB2023Max


## À propos

Ce projet de travail de bachelor au sein de la HES-SO d'Hepia propose de détecter des erreurs de remplissage dans des coffrets de produits cosmétiques.
Pour cela deux approches sont appliqués :

- Algorithme de traitement d'image traditionnel
- Algorithme de deep learning

Ces deux algorithmes sont développés sur python 3.10.


## Table des matières

- 🪧 [À propos](#à-propos)
- 📦 [Prérequis](#prérequis)
- 🚀 [Installation](#installation)
- 🛠️ [Utilisation](#utilisation)
- 📝 [Status](#En développement)

## Prérequis

Pour pouvoir utiliser entraîner le modèle siamois (algorithme de deep learning) voici les modules nécessaires :

    - os
    - tensorflow.keras.models
    - tensorflow.keras.layers
    - tensorflow.keras.optimizers
    - tensorflow.keras.datasets
    - imutils
    - numpy
    - cv2 (OpenCV)
    - csv
    - matplotlib.pyplot
    - keras_preprocessing.image
    - tensorflow.keras.backend
    - PIL
    - matplotlib.colors.Normalize
    - random

Pour l'algorithme classique voici les modules à installer :

    - os
    - mes_fonctions (fichier python inclus dans le dossier méthode traditionnel)
    - skimage.metrics.structural_similarity
    - argparse
    - imutils
    - cv2 (OpenCV)
    - matplotlib.pyplot
    - numpy
    - PIL.Image

Assurez vous d'avoir la version python 3.10 ou + .

L'algorithme traditionnel s'inspire de l'article : " Image Difference with OpenCV and Python "

https://pyimagesearch.com/2017/06/19/image-difference-with-opencv-and-python/

L'algorithme de deep learning s'inspire de ces articles : 

" SigNet: Convolutional Siamese Network for Writer Independent Offline Signature Verification "
https://arxiv.org/abs/1707.02131


" Siamese networks with Keras, TensorFlow, and Deep Learning " 
https://pyimagesearch.com/2020/11/30/siamese-networks-with-keras-tensorflow-and-deep-learning/



## Utilisation

Il y a des figures avec des schémas fonctionnels dans chacun des dossiers des algorithmes récapitulant les différentes fonctions et processus d'utilisation du programme.

Globlament pour le modèle siamois il faut :

1. Charger les dossiers d'images (un dossier principale qui s'appelle "image", deux sous-dossiers qui s'appellent "Modifier" (image avec une erreur) et "Référence" (image de référence)  )
2. Créer des paires d'images de référence d'entraînement avec une augmentation de donnée (sur les images)
3. Créer des paires d'images d'entraînement avec une image contenant une erreur
4. Préparer les données pour le modèle
5. Répéter les opérations 2 à 4 pour les données de validations
6. Entraîner le modèle (sauvegarder les figures d'entraînement, sauvegarder le modèle)

Globalement pour l'algorithme traditionnel

1. Charger les dossiers d'images (un dossier principale qui s'appelle "image", deux sous-dossiers qui s'appellent "Modifier" (image avec une erreur) et "Référence" (image de référence)  )
2. Charger une paire d'image
3. Détection de contour et mise en correspondance avec l'image contenant une erreur
4. Appliquer la différence, le seuillage et la détection de contour
5. Pour terminer afficher le résultat


## Construit avec

### Langages & Frameworks

Python
Framework open source de Tensorflow et Keras

## Status

Actuellement, le projet est encore en cours d'amélioration et de développement afin d'intégrer une interface graphique permettant de contrôler une image en continue et appliquer une des deux algorithmes pour obtenir un résultat en appuyant sur un bouton.


